#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int axtoi(char *hexStg) {
  int n = 0;         // position in string
  int m = 0;         // position in digit[] to shift
  int count;         // loop index
  int intValue = 0;  // integer value of hex string
  int digit[5];      // hold values to convert
  while (n < 4) {
     if (hexStg[n]=='\0')
        break;
     if (hexStg[n] > 0x29 && hexStg[n] < 0x40 ) //if 0 to 9
        digit[n] = hexStg[n] & 0x0f;            //convert to int
     else if (hexStg[n] >='a' && hexStg[n] <= 'f') //if a to f
        digit[n] = (hexStg[n] & 0x0f) + 9;      //convert to int
     else if (hexStg[n] >='A' && hexStg[n] <= 'F') //if A to F
        digit[n] = (hexStg[n] & 0x0f) + 9;      //convert to int
     else break;
    n++;
  }
  count = n;
  m = n - 1;
  n = 0;
  while(n < count) {
     // digit[n] is value of hex digit at position n
     // (m << 2) is the number of positions to shift
     // OR the bits into return value
     intValue = intValue | (digit[n] << (m << 2));
     m--;   // adjust the position to set
     n++;   // next digit to process
  }
  return (intValue);
}


int main()
{
  char buffer[32];

  strcpy(buffer, "0x3f");

  unsigned char cmd1, cmd2, cmd;

  if(strlen(buffer) < 4)
    {
      cmd1 = 0;
      cmd2 = buffer[2];
    }
  else
    {
      cmd1 = buffer[2];
      cmd2 = buffer[3];
    }
  
  cmd = ((cmd1 << 4) & 0xf0) | cmd2;


  printf("a: %d  b: %d Cmd: %d\n", cmd1, cmd2, cmd);
  printf("%i\n", axtoi(buffer+2));

  return 0;
}
  
    
