#ifndef __BALL_H_
#define __BALL_H_

#include <string>

#include "Vector.h"

using namespace std;

class Ball {

	public:
		Ball() {};
		void setName(string n) {name = n;};
		void setPosition(Vector pos) {position = pos;};
		void setVelocity(Vector vel) {velocity = vel;};
		string getName() { return name; };
		Vector getPosition() {return position;};
		Vector getVelocity() {return velocity;};
	       

	private:
		Vector position;
		Vector velocity;
		string name;
	
	
};

#endif
