#ifndef __COMMSERVER_H_
#define __COMMSERVER_H_

#include <stdio.h>
#include <stdlib.h>
#include <curses.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <argp.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>
#include <string.h>

#include <sys/types.h>
#include <netdb.h>
#include <math.h>
#include <sys/wait.h>

#include "Vector.h"
#include "Robot.h"

class CommServer
{
 private:
  int sockfd;  //our socket descriptor  int on;

  struct sockaddr_in sin;  //holds broadcast info

 public:
  CommServer();
  CommServer(int port);
  ~CommServer();
  int init(int port);   //initializes our socket
  int sendData(Robot* robots);
  int sendData();
};

#endif
