#ifndef C_VECTOR2H__
#define C_VECTOR2H__

#include <math.h>
#include <stdio.h>

class Vector
{
	
 public:
  
  Vector() {xcoord = 0; ycoord = 0;};
  Vector(double x, double y);
  Vector operator-(Vector RHS);
  Vector operator+(Vector RHS);
  Vector operator*(double value);
  void operator=(Vector RHS);
  
  double x() {return xcoord;};
  double y() {return ycoord;};
  
  void setX(double x_) { xcoord = x_; };
  void setY(double y_) { ycoord = y_; };

  double dot(Vector RHS);
  double cross(Vector RHS);

  double abs_angle_diff(Vector RHS);  

  double angle(void);
  double magnitude(void);
  Vector normalize(void);

  void print(char* s);
  void print();

 private:
  double xcoord , ycoord;

};

#endif

